SystemOrganization addCategory: #TusLibros!

Object subclass: #Cart
	instanceVariableNames: 'items catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/29/2013 21:04'!
createWithCatalogue: aCatalogue 
	^ self new initializeEmptyWithCatalogue: aCatalogue ! !

!Cart class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 5/29/2013 21:13'!
nonCataloguedBookDescription
	^ 'Catalogue doesnt contain item'! !

!Cart methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 5/29/2013 21:06'!
add: anItem
	self add: anItem withOccurrences: 1.! !

!Cart methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 5/29/2013 21:08'!
add: anItem  withOccurrences: anInteger
	(catalogue includes: anItem) ifFalse: [Error signal: 'Catalogue doesnt contain item'].
	items add: anItem withOccurrences: anInteger! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:25'!
includes: anItem
	^ items includes: anItem! !

!Cart methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/29/2013 21:04'!
initializeEmptyWithCatalogue: aCatalogue
	items:= Bag new.
	catalogue:= aCatalogue ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:21'!
isEmpty
	^ items isEmpty ! !

!Cart methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:40'!
occurrencesOf: anItem
	^ items occurrencesOf: anItem ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:29'!
size
	^ items size! !

Object subclass: #Cashier
	instanceVariableNames: 'priceCatalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 5/29/2013 21:28'!
cartEmptyErrorDescription
	^ 'Cannot check out empy cart'! !

!Cashier class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 5/29/2013 21:33'!
withPriceCatalogue: aDictionary 
	^ self new initializeWithCatalogue: aDictionary .! !

!Cashier methodsFor: 'apply primitives' stamp: 'EtchegoyenLajePulver 5/29/2013 21:57'!
checkout: aCart
	aCart isEmpty ifTrue: [ ^ Error signal: self class cartEmptyErrorDescription ].
	
"	Sale "! !

!Cashier methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/29/2013 21:27'!
initializeWithCatalogue: aDictionary 
	priceCatalogue:= aDictionary ! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/29/2013 21:22'!
aCashier
	^ Cashier withPriceCatalogue: self aPriceCatalogue! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:03'!
aCatalogue
	^ Set newFrom: {self aTestBook. self anotherTestBook.}! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
aNonCataloguedTestBook 
	^ '3'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/29/2013 21:25'!
aPriceCatalogue 
	^ Dictionary newFromPairs: {self aTestBook. 10. self anotherTestBook. 30}! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
aTestBook 
	^ '1'! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:05'!
anEmptyCart
	^ Cart createWithCatalogue: self aCatalogue ! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
anotherTestBook 
	^ '2'! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test01NewCartShouldBeEmpty
	self assert: self anEmptyCart isEmpty! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test02BookShouldBePresentAfterBeingAdded
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	aCart add: aBook.
	
	self assert: (aCart includes: aBook)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test03CartShouldNotBeEmptyAfterAddingBook
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	aCart add: aBook.
	
	self deny: (aCart isEmpty)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test04EmptyCartHasSize0
	|aCart|
	aCart:= self anEmptyCart.
	self assert: (aCart size = 0)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test05EachAddedBookIncreasesCartSize
	|aCart aBook anotherBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anotherBook := self anotherTestBook.

	self assert: (aCart size = 0).
	aCart add: aBook.
	self assert: (aCart size = 1).
	aCart add: anotherBook.
	self assert: (aCart size = 2).! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test06OnlyAddedBooksShouldBePresent
	|aCart aBook anotherBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anotherBook:= self anotherTestBook.
	aCart add: aBook.
	
	self assert: (aCart includes: aBook).
	self deny: (aCart includes: anotherBook).
	self assert: (aCart size = 1)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test07BookNotAddedToCartHasNoOcurrencesInCart
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	
	self assert: ((aCart occurrencesOf: aBook) = 0)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test08EachBookAddedToCartIncreasesOccurrencesInCart
	|aCart aBook anotherBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anotherBook:= self anotherTestBook.
	
	aCart add: aBook.
	self assert: ((aCart occurrencesOf: aBook) = 1).
	aCart add: aBook.
	self assert: ((aCart occurrencesOf: aBook) = 2).
	self assert: ((aCart occurrencesOf: anotherBook) = 0)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test09AddingBooksWithQuantityIncreasesOccurrencesSameQuantity
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
		
	aCart add: aBook.
	aCart add: aBook withOccurrences: 9.
	self assert: ((aCart occurrencesOf: aBook) = 10).! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:11'!
test10NonCataloguedBooksShouldntBeAbleToBeAdded
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aNonCataloguedTestBook.
		
	self should: [aCart add: aBook] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart nonCataloguedBookDescription ].
! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 5/29/2013 21:20'!
test11ShouldntBeAbleToCheckOutEmptyCart
	| aCart aCashier |
	aCart := self anEmptyCart.
	aCashier := self aCashier.
	
	self should: [aCashier checkout: aCart]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ]! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 5/29/2013 21:38'!
test12CashierShouldCalculateRightTotalAmount
	| aCart aCashier aBook anotherBook |
	aCart := self anEmptyCart.
	aCashier := self aCashier.
	aBook:= self aTestBook.
	anotherBook := self anotherTestBook.
	aCart add: aBook.
	aCart add: anotherBook.
	
	self assert: ((aCashier checkout: aCart) amount = 40)! !
